<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirCoupon ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirCoupon
 * @subpackage Arrays
 */
class ArrayOfAirCoupon extends AbstractStructArrayBase
{
    /**
     * The AirCoupon
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\AirCoupon[]
     */
    public $AirCoupon;
    /**
     * Constructor method for ArrayOfAirCoupon
     * @uses ArrayOfAirCoupon::setAirCoupon()
     * @param \App|C\StructType\AirCoupon[] $airCoupon
     */
    public function __construct(array $airCoupon = array())
    {
        $this
            ->setAirCoupon($airCoupon);
    }
    /**
     * Get AirCoupon value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\AirCoupon[]|null
     */
    public function getAirCoupon()
    {
        return isset($this->AirCoupon) ? $this->AirCoupon : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirCoupon method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirCoupon method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirCouponForArrayConstraintsFromSetAirCoupon(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirCouponAirCouponItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirCouponAirCouponItem instanceof \App|C\StructType\AirCoupon) {
                $invalidValues[] = is_object($arrayOfAirCouponAirCouponItem) ? get_class($arrayOfAirCouponAirCouponItem) : sprintf('%s(%s)', gettype($arrayOfAirCouponAirCouponItem), var_export($arrayOfAirCouponAirCouponItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirCoupon property can only contain items of type \App|C\StructType\AirCoupon, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirCoupon value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\AirCoupon[] $airCoupon
     * @return \App|C\ArrayType\ArrayOfAirCoupon
     */
    public function setAirCoupon(array $airCoupon = array())
    {
        // validation for constraint: array
        if ('' !== ($airCouponArrayErrorMessage = self::validateAirCouponForArrayConstraintsFromSetAirCoupon($airCoupon))) {
            throw new \InvalidArgumentException($airCouponArrayErrorMessage, __LINE__);
        }
        if (is_null($airCoupon) || (is_array($airCoupon) && empty($airCoupon))) {
            unset($this->AirCoupon);
        } else {
            $this->AirCoupon = $airCoupon;
        }
        return $this;
    }
    /**
     * Add item to AirCoupon value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\AirCoupon $item
     * @return \App|C\ArrayType\ArrayOfAirCoupon
     */
    public function addToAirCoupon(\App|C\StructType\AirCoupon $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\AirCoupon) {
            throw new \InvalidArgumentException(sprintf('The AirCoupon property can only contain items of type \App|C\StructType\AirCoupon, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirCoupon[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\AirCoupon|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\AirCoupon|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\AirCoupon|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\AirCoupon|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\AirCoupon|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirCoupon
     */
    public function getAttributeName()
    {
        return 'AirCoupon';
    }
}
