<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBookingClass ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfBookingClass
 * @subpackage Arrays
 */
class ArrayOfBookingClass extends AbstractStructArrayBase
{
    /**
     * The BookingClass
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\BookingClass[]
     */
    public $BookingClass;
    /**
     * Constructor method for ArrayOfBookingClass
     * @uses ArrayOfBookingClass::setBookingClass()
     * @param \App|C\StructType\BookingClass[] $bookingClass
     */
    public function __construct(array $bookingClass = array())
    {
        $this
            ->setBookingClass($bookingClass);
    }
    /**
     * Get BookingClass value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\BookingClass[]|null
     */
    public function getBookingClass()
    {
        return isset($this->BookingClass) ? $this->BookingClass : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBookingClass method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBookingClass method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBookingClassForArrayConstraintsFromSetBookingClass(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfBookingClassBookingClassItem) {
            // validation for constraint: itemType
            if (!$arrayOfBookingClassBookingClassItem instanceof \App|C\StructType\BookingClass) {
                $invalidValues[] = is_object($arrayOfBookingClassBookingClassItem) ? get_class($arrayOfBookingClassBookingClassItem) : sprintf('%s(%s)', gettype($arrayOfBookingClassBookingClassItem), var_export($arrayOfBookingClassBookingClassItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BookingClass property can only contain items of type \App|C\StructType\BookingClass, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BookingClass value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\BookingClass[] $bookingClass
     * @return \App|C\ArrayType\ArrayOfBookingClass
     */
    public function setBookingClass(array $bookingClass = array())
    {
        // validation for constraint: array
        if ('' !== ($bookingClassArrayErrorMessage = self::validateBookingClassForArrayConstraintsFromSetBookingClass($bookingClass))) {
            throw new \InvalidArgumentException($bookingClassArrayErrorMessage, __LINE__);
        }
        if (is_null($bookingClass) || (is_array($bookingClass) && empty($bookingClass))) {
            unset($this->BookingClass);
        } else {
            $this->BookingClass = $bookingClass;
        }
        return $this;
    }
    /**
     * Add item to BookingClass value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\BookingClass $item
     * @return \App|C\ArrayType\ArrayOfBookingClass
     */
    public function addToBookingClass(\App|C\StructType\BookingClass $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\BookingClass) {
            throw new \InvalidArgumentException(sprintf('The BookingClass property can only contain items of type \App|C\StructType\BookingClass, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BookingClass[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\BookingClass|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\BookingClass|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\BookingClass|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\BookingClass|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\BookingClass|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BookingClass
     */
    public function getAttributeName()
    {
        return 'BookingClass';
    }
}
