<?php
/**
 * This file aims to show you how to use this generated package.
 * In addition, the goal is to show which methods are available and the first needed parameter(s)
 * You have to use an associative array such as:
 * - the key must be a constant beginning with WSDL_ from AbstractSoapClientBase class (each generated ServiceType class extends this class)
 * - the value must be the corresponding key value (each option matches a {@link http://www.php.net/manual/en/soapclient.soapclient.php} option)
 * $options = array(
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'http://tstws2.ttinteractive.com/Zenith/TTI.PublicApi.Services/SoapSaleEngineService.svc?singleWsdl',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_TRACE => true,
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_LOGIN => 'you_secret_login',
 * \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_PASSWORD => 'you_secret_password',
 * );
 * etc...
 */
require_once __DIR__ . '/vendor/autoload.php';
/**
 * Minimal options
 */
$options = array(
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_URL => 'http://tstws2.ttinteractive.com/Zenith/TTI.PublicApi.Services/SoapSaleEngineService.svc?singleWsdl',
    \WsdlToPhp\PackageBase\AbstractSoapClientBase::WSDL_CLASSMAP => \App|C\ClassMap::get(),
);
/**
 * Samples for Preload ServiceType
 */
$preload = new \App|C\ServiceType\Preload($options);
/**
 * Sample call for Preload operation/method
 */
if ($preload->Preload(new \App|C\StructType\Preload()) !== false) {
    print_r($preload->getResult());
} else {
    print_r($preload->getLastError());
}
/**
 * Samples for Ping ServiceType
 */
$ping = new \App|C\ServiceType\Ping($options);
/**
 * Sample call for Ping operation/method
 */
if ($ping->Ping(new \App|C\StructType\Ping()) !== false) {
    print_r($ping->getResult());
} else {
    print_r($ping->getLastError());
}
/**
 * Samples for Authenticate ServiceType
 */
$authenticate = new \App|C\ServiceType\Authenticate($options);
/**
 * Sample call for AuthenticateCredentials operation/method
 */
if ($authenticate->AuthenticateCredentials(new \App|C\StructType\AuthenticateCredentials()) !== false) {
    print_r($authenticate->getResult());
} else {
    print_r($authenticate->getLastError());
}
/**
 * Samples for Sale ServiceType
 */
$sale = new \App|C\ServiceType\Sale($options);
/**
 * Sample call for SaleConfiguration operation/method
 */
if ($sale->SaleConfiguration(new \App|C\StructType\SaleConfiguration()) !== false) {
    print_r($sale->getResult());
} else {
    print_r($sale->getLastError());
}
/**
 * Samples for Get ServiceType
 */
$get = new \App|C\ServiceType\Get($options);
/**
 * Sample call for GetValueCodeList operation/method
 */
if ($get->GetValueCodeList(new \App|C\StructType\GetValueCodeList()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Sample call for GetValueCodes operation/method
 */
if ($get->GetValueCodes(new \App|C\StructType\GetValueCodes()) !== false) {
    print_r($get->getResult());
} else {
    print_r($get->getLastError());
}
/**
 * Samples for Eligible ServiceType
 */
$eligible = new \App|C\ServiceType\Eligible($options);
/**
 * Sample call for EligibleOriginDestinations operation/method
 */
if ($eligible->EligibleOriginDestinations(new \App|C\StructType\EligibleOriginDestinations()) !== false) {
    print_r($eligible->getResult());
} else {
    print_r($eligible->getLastError());
}
/**
 * Samples for Calendar ServiceType
 */
$calendar = new \App|C\ServiceType\Calendar($options);
/**
 * Sample call for Calendar operation/method
 */
if ($calendar->Calendar(new \App|C\StructType\Calendar()) !== false) {
    print_r($calendar->getResult());
} else {
    print_r($calendar->getLastError());
}
/**
 * Samples for Search ServiceType
 */
$search = new \App|C\ServiceType\Search($options);
/**
 * Sample call for SearchFlights operation/method
 */
if ($search->SearchFlights(new \App|C\StructType\SearchFlights()) !== false) {
    print_r($search->getResult());
} else {
    print_r($search->getLastError());
}
/**
 * Sample call for SearchBooking operation/method
 */
if ($search->SearchBooking(new \App|C\StructType\SearchBooking()) !== false) {
    print_r($search->getResult());
} else {
    print_r($search->getLastError());
}
/**
 * Sample call for SearchFlightsForExchange operation/method
 */
if ($search->SearchFlightsForExchange(new \App|C\StructType\SearchFlightsForExchange()) !== false) {
    print_r($search->getResult());
} else {
    print_r($search->getLastError());
}
/**
 * Samples for Prepare ServiceType
 */
$prepare = new \App|C\ServiceType\Prepare($options);
/**
 * Sample call for PrepareFlights operation/method
 */
if ($prepare->PrepareFlights(new \App|C\StructType\PrepareFlights()) !== false) {
    print_r($prepare->getResult());
} else {
    print_r($prepare->getLastError());
}
/**
 * Sample call for PrepareBookingModification operation/method
 */
if ($prepare->PrepareBookingModification(new \App|C\StructType\PrepareBookingModification()) !== false) {
    print_r($prepare->getResult());
} else {
    print_r($prepare->getLastError());
}
/**
 * Sample call for PrepareExchange operation/method
 */
if ($prepare->PrepareExchange(new \App|C\StructType\PrepareExchange()) !== false) {
    print_r($prepare->getResult());
} else {
    print_r($prepare->getLastError());
}
/**
 * Sample call for PrepareCheckin operation/method
 */
if ($prepare->PrepareCheckin(new \App|C\StructType\PrepareCheckin()) !== false) {
    print_r($prepare->getResult());
} else {
    print_r($prepare->getLastError());
}
/**
 * Sample call for PrepareCancel operation/method
 */
if ($prepare->PrepareCancel(new \App|C\StructType\PrepareCancel()) !== false) {
    print_r($prepare->getResult());
} else {
    print_r($prepare->getLastError());
}
/**
 * Samples for Create ServiceType
 */
$create = new \App|C\ServiceType\Create($options);
/**
 * Sample call for CreateBooking operation/method
 */
if ($create->CreateBooking(new \App|C\StructType\CreateBooking()) !== false) {
    print_r($create->getResult());
} else {
    print_r($create->getLastError());
}
/**
 * Sample call for CreateTicket operation/method
 */
if ($create->CreateTicket(new \App|C\StructType\CreateTicket()) !== false) {
    print_r($create->getResult());
} else {
    print_r($create->getLastError());
}
/**
 * Samples for Load ServiceType
 */
$load = new \App|C\ServiceType\Load($options);
/**
 * Sample call for LoadBooking operation/method
 */
if ($load->LoadBooking(new \App|C\StructType\LoadBooking()) !== false) {
    print_r($load->getResult());
} else {
    print_r($load->getLastError());
}
/**
 * Sample call for LoadCustomer operation/method
 */
if ($load->LoadCustomer(new \App|C\StructType\LoadCustomer()) !== false) {
    print_r($load->getResult());
} else {
    print_r($load->getLastError());
}
/**
 * Sample call for LoadFrequentFlyerAccount operation/method
 */
if ($load->LoadFrequentFlyerAccount(new \App|C\StructType\LoadFrequentFlyerAccount()) !== false) {
    print_r($load->getResult());
} else {
    print_r($load->getLastError());
}
/**
 * Samples for Send ServiceType
 */
$send = new \App|C\ServiceType\Send($options);
/**
 * Sample call for SendTicketConfirmation operation/method
 */
if ($send->SendTicketConfirmation(new \App|C\StructType\SendTicketConfirmation()) !== false) {
    print_r($send->getResult());
} else {
    print_r($send->getLastError());
}
/**
 * Samples for Modify ServiceType
 */
$modify = new \App|C\ServiceType\Modify($options);
/**
 * Sample call for ModifyBooking operation/method
 */
if ($modify->ModifyBooking(new \App|C\StructType\ModifyBooking()) !== false) {
    print_r($modify->getResult());
} else {
    print_r($modify->getLastError());
}
/**
 * Samples for Exchange ServiceType
 */
$exchange = new \App|C\ServiceType\Exchange($options);
/**
 * Sample call for Exchange operation/method
 */
if ($exchange->Exchange(new \App|C\StructType\Exchange()) !== false) {
    print_r($exchange->getResult());
} else {
    print_r($exchange->getLastError());
}
/**
 * Samples for Cancel ServiceType
 */
$cancel = new \App|C\ServiceType\Cancel($options);
/**
 * Sample call for CancelPendingExchange operation/method
 */
if ($cancel->CancelPendingExchange(new \App|C\StructType\CancelPendingExchange()) !== false) {
    print_r($cancel->getResult());
} else {
    print_r($cancel->getLastError());
}
/**
 * Sample call for Cancel operation/method
 */
if ($cancel->Cancel(new \App|C\StructType\Cancel()) !== false) {
    print_r($cancel->getResult());
} else {
    print_r($cancel->getLastError());
}
/**
 * Samples for Checkin ServiceType
 */
$checkin = new \App|C\ServiceType\Checkin($options);
/**
 * Sample call for Checkin operation/method
 */
if ($checkin->Checkin(new \App|C\StructType\Checkin()) !== false) {
    print_r($checkin->getResult());
} else {
    print_r($checkin->getLastError());
}
/**
 * Samples for Uncheck ServiceType
 */
$uncheck = new \App|C\ServiceType\Uncheck($options);
/**
 * Sample call for Uncheck operation/method
 */
if ($uncheck->Uncheck(new \App|C\StructType\Uncheck()) !== false) {
    print_r($uncheck->getResult());
} else {
    print_r($uncheck->getLastError());
}
/**
 * Samples for New ServiceType
 */
$new = new \App|C\ServiceType\_New($options);
/**
 * Sample call for NewCustomer operation/method
 */
if ($new->NewCustomer(new \App|C\StructType\NewCustomer()) !== false) {
    print_r($new->getResult());
} else {
    print_r($new->getLastError());
}
/**
 * Samples for Update ServiceType
 */
$update = new \App|C\ServiceType\Update($options);
/**
 * Sample call for UpdateCustomer operation/method
 */
if ($update->UpdateCustomer(new \App|C\StructType\UpdateCustomer()) !== false) {
    print_r($update->getResult());
} else {
    print_r($update->getLastError());
}
/**
 * Samples for Lost ServiceType
 */
$lost = new \App|C\ServiceType\Lost($options);
/**
 * Sample call for LostCustomerPassword operation/method
 */
if ($lost->LostCustomerPassword(new \App|C\StructType\LostCustomerPassword()) !== false) {
    print_r($lost->getResult());
} else {
    print_r($lost->getLastError());
}
/**
 * Samples for Change ServiceType
 */
$change = new \App|C\ServiceType\Change($options);
/**
 * Sample call for ChangeCustomerPassword operation/method
 */
if ($change->ChangeCustomerPassword(new \App|C\StructType\ChangeCustomerPassword()) !== false) {
    print_r($change->getResult());
} else {
    print_r($change->getLastError());
}
/**
 * Samples for Activate ServiceType
 */
$activate = new \App|C\ServiceType\Activate($options);
/**
 * Sample call for ActivateFrequentFlyerAccount operation/method
 */
if ($activate->ActivateFrequentFlyerAccount(new \App|C\StructType\ActivateFrequentFlyerAccount()) !== false) {
    print_r($activate->getResult());
} else {
    print_r($activate->getLastError());
}
/**
 * Samples for Frequent ServiceType
 */
$frequent = new \App|C\ServiceType\Frequent($options);
/**
 * Sample call for FrequentFlyerMileageCalculator operation/method
 */
if ($frequent->FrequentFlyerMileageCalculator(new \App|C\StructType\FrequentFlyerMileageCalculator()) !== false) {
    print_r($frequent->getResult());
} else {
    print_r($frequent->getLastError());
}
/**
 * Samples for Event ServiceType
 */
$event = new \App|C\ServiceType\Event($options);
/**
 * Sample call for EventMap operation/method
 */
if ($event->EventMap(new \App|C\StructType\EventMap()) !== false) {
    print_r($event->getResult());
} else {
    print_r($event->getLastError());
}
/**
 * Samples for Flown ServiceType
 */
$flown = new \App|C\ServiceType\Flown($options);
/**
 * Sample call for FlownCoupons operation/method
 */
if ($flown->FlownCoupons(new \App|C\StructType\FlownCoupons()) !== false) {
    print_r($flown->getResult());
} else {
    print_r($flown->getLastError());
}
